/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 26/10/2017
 --------------------------------------------------------
*/
package com.portofolio.dao;

import java.util.Map;

import org.springframework.context.annotation.Lazy;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import com.portofolio.entity.Title;
import com.portofolio.entity.vo.TitleId;

@Lazy
@Repository
public interface TitleDao extends CrudRepository<Title, TitleId> {

	@Query(QListAll)
	Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile,@Param("statusEnabled") boolean statusEnabled, Pageable page);

	@Query(QListAll + " and model.namaTitle like %:namaTitle% ")
	Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile,@Param("namaTitle") String namaTitle, @Param("statusEnabled") boolean statusEnabled,Pageable page);

	@Query(QListAll + " and model.id.kdTitle = :kdTitle")
	Map<String, Object> findByKdTitle(@Param("kdProfile") Integer kdProfile,@Param("kdTitle") Integer kdTitle, @Param("statusEnabled") boolean statusEnabled);

    
    
    String QListAll ="select new map(model.id.kdTitle as kdKdTitle,model.id.kdProfile as kdProfile "
            + ", model.namaTitle as namaTitle " 
            + ", model.reportDisplay as reportDisplay " 
            + ", model.kodeExternal as kodeExternal " 
            + ", model.namaExternal as namaExternal " 
            + ", model.statusEnabled as statusEnabled " 
            + ", model.noRec as noRec " 
            + ", model.version as version )" 
            + " from Title model left join model.id id "
            + " where id.kdProfile=:kdProfile "
            + " and model.statusEnabled = :statusEnabled "; 

}
